package com.cicdi.notify.dingtalk;

import com.alibaba.fastjson.JSON;
import com.cicdi.notify.*;
import com.cicdi.notify.template.AbstractTemplateManager;
import com.cicdi.notify.template.Template;
import com.cicdi.notify.template.TemplateManager;
import com.cicdi.notify.template.TemplateProperties;
import org.junit.Before;
import org.junit.Test;

import java.util.HashMap;
import java.util.Map;

/**
 * @author xueye
 */
public class DingTalkTest {
    /**
     * 模板管理器
     */
    private TemplateManager templateManager;
    /**
     * 通知器管理器
     */
    private NotifierManager notifierManager;

    /**
     * 测试钉钉消息发送
     */
    @Test
    public void test() {
        Notifier<Template> notifier = notifierManager.getNotifier(DefaultNotifyType.dingTalk, "123");
        notifier.send(templateManager.getTemplate(DefaultNotifyType.dingTalk, "124"), new HashMap<>());
    }

    @Before
    public void init() {
        // 通知器配置管理器
        NotifyConfigManager notifyConfigManager = (notifyType, configId) -> {
            NotifierProperties notifierProperties = new NotifierProperties();
            notifierProperties.setType(DefaultNotifyType.dingTalk.getId());
            notifierProperties.setProvider(DingTalkProvider.dingTalkMessage.getId());
            notifierProperties.setId("123");

            Map<String, Object> config = new HashMap<>();
            config.put("appKey", "dinga5vkkpbrwqc0fmni");
            config.put("appSecret", "ARsEfA8CQ7RxJabEW1TecTeEItTamK3GQ8-TfWTHAydF7gQK16N23UuN9y2E9raq");

            notifierProperties.setConfiguration(config);

            return notifierProperties;
        };

        templateManager = new AbstractTemplateManager() {
            @Override
            protected TemplateProperties getProperties(NotifyType type, String id) {
                TemplateProperties templateProperties = new TemplateProperties();
                templateProperties.setType(DefaultNotifyType.dingTalk.getId());
                templateProperties.setProvider(DingTalkProvider.dingTalkMessage.getId());

                DingTalkMessageTemplate template = new DingTalkMessageTemplate();
                template.setAgentId("1211676948");
                template.setUserIdList("manager276");
                template.setDepartmentIdList("");
                template.setToAllUser(false);
                template.setMessage("Hello World! - " + System.currentTimeMillis());

                templateProperties.setTemplate(JSON.toJSONString(template));

                return templateProperties;
            }
        };

        notifierManager = new AbstractNotifierManager(notifyConfigManager) {
        };

        // register
        DingTalkNotifierProvider provider = new DingTalkNotifierProvider(templateManager);
        notifierManager.register(provider);
        templateManager.register(provider);
    }

}
