package com.cicdi.notify.wechat.subscription;

import com.alibaba.fastjson.JSONObject;
import com.cicdi.notify.template.Template;

import java.util.Map;

/**
 * 微信公众号消息模板
 *
 * @author xueye
 */
public class WechatSubscriptionTemplate implements Template {

    /**
     * 接收者openid
     */
    private String toUser;

    /**
     * 模板ID
     */
    private String templateId;

    /**
     * 模板跳转链接（海外帐号没有跳转能力）
     */
    private String url;

    /**
     * 跳小程序所需数据，不需跳小程序可不用传该数据
     * <ul>
     *     <li>appid：所需跳转到的小程序appid（该小程序appid必须与发模板消息的公众号是绑定关联关系，暂不支持小游戏）</li>
     *     <li>pagepath：所需跳转到小程序的具体页面路径，支持带参数,（示例index?foo=bar），要求该小程序已发布，暂不支持小游戏</li>
     * </ul>
     */
    private Map<String, Object> miniProgram;

    /**
     * 模板数据
     * <ul>
     *     <li>keyword：模板数据名称</li>
     *     <li><ul>
     *         <li>value：模板数据值</li>
     *         <li>color：模板内容字体颜色，不填默认为黑色</li>
     *     </ul></li>
     * </ul>
     */
    private Map<String, Object> data;

    public String createJsonRequest() {
        JSONObject json = new JSONObject();
        json.put("touser", toUser);
        json.put("template_id", templateId);
        json.put("url", url);
        json.put("miniprogram", miniProgram);
        json.put("data", data);
        return json.toJSONString();
    }

    public String getToUser() {
        return toUser;
    }

    public void setToUser(String toUser) {
        this.toUser = toUser;
    }

    public String getTemplateId() {
        return templateId;
    }

    public void setTemplateId(String templateId) {
        this.templateId = templateId;
    }

    public String getUrl() {
        return url;
    }

    public void setUrl(String url) {
        this.url = url;
    }

    public Map<String, Object> getMiniProgram() {
        return miniProgram;
    }

    public void setMiniProgram(Map<String, Object> miniProgram) {
        this.miniProgram = miniProgram;
    }

    public Map<String, Object> getData() {
        return data;
    }

    public void setData(Map<String, Object> data) {
        this.data = data;
    }
}
